      subroutine ffint(s,t,k,lq,lp,nR,dR,amu,u1,u2,fac0,ff)
      implicit real*8(a-h,o-z)
      include 'parameter.f'
      real*8     u1(0:nR),u2(0:nR),ff(0:nRmax,2)
      integer*4  s,t,k
      parameter (maxmu=5)
      real*8     V0(0:1,0:1,3,2,maxmu),mu(0:1,0:1,3,2,maxmu),A(0:2)
      integer*4  nm(0:1,0:1,3,2) ! s,t,type,r/i
      save       nm,V0,mu,A,pi4
      real*8     Blq(0:nRmax),Hlq(0:nRmax),Blp(0:nRmax),Hlp(0:nRmax)
      character  type(3)*12,rori(2)*4
      data       type/'Yukawa','Delta','r^2*Yukawa'/
      data       rori/'Real','Imag'/,nm/24*0/
      fac=fac0*A(k)*dR/amu
      goto (10000,20000) k/2+1
c     central interactions
10000 do ir=1,2
c        Yukawa
         do im=1,nm(s,t,1,ir)
            call bessel(lq,nR,dR,mu(s,t,1,ir,im),Blq,Hlq)
            V=pi4*V0(s,t,1,ir,im)*fac
            do iy=0,nR
               do ix=1,nR
                  ff(iy,ir)=ff(iy,ir)+
     &                 u1(ix)*u2(ix)*V*Blq(min(ix,iy))*Hlq(max(ix,iy))
               enddo
            enddo
         enddo
c        Delta
         do im=1,nm(s,t,2,ir)
            V=V0(s,t,2,ir,im)/dR*fac
            do iy=1,nR
               ff(iy,ir)=ff(iy,ir)+u1(iy)*u2(iy)*V/(iy*dR)**2
            enddo
         enddo
      enddo
      return
c     tensor interaction(s)
20000 do ir=1,2
c        r^2*Yukawa
         do im=1,nm(s,t,3,ir)
            call bessel(lq,nR,dR,mu(s,t,3,ir,im),Blq,Hlq)
            call bessel(lp,nR,dR,mu(s,t,3,ir,im),Blp,Hlp)
            V=pi4*V0(s,t,3,ir,im)*fac
            do iy=0,nR
               y=iy*dR
               do ix=1,nR
                  x=ix*dR
                  ff(iy,ir)=ff(iy,ir)+u1(ix)*u2(ix)*V*(
     &                 y*y*Blq(min(ix,iy))*Hlq(max(ix,iy))+
     &                 x*x*Blp(min(ix,iy))*Hlp(max(ix,iy)))
               enddo
            enddo
            do lx=max(abs(lp-1),abs(lq-1)),min(lp+1,lq+1),2
               if (lq.ne.lp) then
                  al=2.D0
               else
                  if (lx.lt.lp) then
                     al=(2.D0*lp+3.D0)/(2.D0*lp+1.D0)
                  else
                     al=(2.D0*lp-1.D0)/(2.D0*lp+1.D0)
                  endif
               endif
               call bessel(lx,nR,dR,mu(s,t,3,ir,im),Blq,Hlq)
               do iy=0,nR
                  y=iy*dR
                  do ix=1,nR
                     x=ix*dR
                     ff(iy,ir)=ff(iy,ir)-al*u1(ix)*u2(ix)*V
     &                    *x*y*Blq(min(ix,iy))*Hlq(max(ix,iy))
                  enddo
               enddo
            enddo
         enddo
      enddo
      return
c     read-in eff. int. potential parameters
      entry ffint0
      write(6,'(/A/)') ' two-nucleon effective interactions.'
      is=0
      do while (is.ge.0)
         read(5,*) is,it,ix,ir,nm(is,it,ix,ir),
     &        (V0(is,it,ix,ir,i),mu(is,it,ix,ir,i),i=1,nm(is,it,ix,ir))
         if (nm(is,it,ix,ir).gt.maxmu) goto 90000
      enddo
      do is=0,1
         do it=0,1
            do ix=1,3
               do ir=1,2
                  if (nm(is,it,ix,ir).ne.0) then
                     write(6,'(2(A,I1),4A)') '  s=',is,', t=',it,', ',
     &                    type(ix)(:index(type(ix),' ')-1),'-',rori(ir)
                     write(6,*) (' (',V0(is,it,ix,ir,i),',',
     &                    mu(is,it,ix,ir,i),')',i=1,nm(is,it,ix,ir))
                  endif
               enddo
            enddo
         enddo
      enddo
      A(0)=+1.D0
      A(2)=-sqrt(2.D0)
      pi4=atan(1.D0)*4.D0*4.D0
      return
90000 write(0,*) 'error in ffint'
      stop 1024
      end
